searchData={"items":[{"type":"module","title":"Railway","doc":"Railway pipe operator.","ref":"Railway.html"},{"type":"function","title":"Railway.unwrap/2","doc":"The ~>> operator introduces the value of an {:ok, value} tuple on the left-hand side\nas the first argument to the function call on the right-hand side.\n\nIf the tuple on the left-hand side is anything different from {:ok, value} like {:error, reason}\nthe ~>> operator will just return the left-hand side and not execute the function call on the right.\n\nIf the expression on the left-hand side is not a tuple, the ~>> operator will behave just like |> does.","ref":"Railway.html#unwrap/2"},{"type":"function","title":"Examples - Railway.unwrap/2","doc":"iex> use Railway\n    iex> {:ok, \"some string\"} ~>> String.upcase()\n    \"SOME STRING\"\n\n    iex> use Railway\n    iex> {:error, \"some string\"} ~>> String.upcase()\n    {:error, \"some string\"}","ref":"Railway.html#unwrap/2-examples"},{"type":"macro","title":"Railway.~>>/2","doc":"","ref":"Railway.html#~%3E%3E/2"},{"type":"extras","title":"Railway","doc":"# Railway\n\n**Pipe result tuples `{:ok, value}` all the way. Noop if the first element differs from `:ok`**\n\n[![Tests](https://github.com/sorax/railway/actions/workflows/test.yml/badge.svg)](https://github.com/sorax/railway/actions/workflows/test.yml)\n[![Code Quality](https://github.com/sorax/railway/actions/workflows/quality.yml/badge.svg)](https://github.com/sorax/railway/actions/workflows/quality.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/railway.svg)](https://hex.pm/packages/railway)\n[![hexdocs.pm](https://img.shields.io/badge/docs-1.1.0-brightgreen.svg)](https://hexdocs.pm/railway/1.1.0/Railway.html)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/railway)](https://hex.pm/packages/railway)\n[![License](https://img.shields.io/hexpm/l/railway.svg)](https://github.com/sorax/railway/blob/min/LICENSE.md)","ref":"readme.html"},{"type":"extras","title":"Installation & Usage - Railway","doc":"Simply add `railway` to your list of dependencies in your `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:railway, \"~> 1.1\"}\n  ]\nend\n```\n\nrun `mix deps.get` and `use Railway` in your Module\n\n```elixir\ndefmodule MyModule do\n  use Railway\n\n  def my_func do\n    \"https://www.example.com/api\"\n    ~>> Req.get()\n    ~>> Map.get(:body)\n    ~>> Jason.decode()\n    ~>> Map.get(\"results\")\n  end\nend\n```","ref":"readme.html#installation-usage"},{"type":"extras","title":"How does ~>> work? - Railway","doc":"The `~>>` operator introduces the value of an `{:ok, value}` tuple on the left-hand side\nas the first argument to the function call on the right-hand side.\n\nIf the tuple on the left-hand side is anything different from `{:ok, value}` like `{:error, reason}`\nthe `~>>` operator will just return the left-hand side and not execute the function call on the right.\n\nIf the expression on the left-hand side is not a tuple, the `~>>` operator will behave just like `|>` does.\n\nDocumentation can be found at https://hexdocs.pm/railway","ref":"readme.html#how-does-work"},{"type":"extras","title":"MIT License","doc":"# MIT License\n\nCopyright (c) 2024 sorax\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}